#include <bits/stdc++.h>
#include <ostream>

#define int long long
#define all(v) v.begin(), v.end()

using namespace std;

struct oper {
    int t;
    int ind;
    char s;

    oper(long long t, long long ind, char s) : t(t), ind(ind), s(s) {}

    oper(long long t, long long ind) : t(t), ind(ind) { assert(t == 2); }

    friend ostream &operator<<(ostream &os, const oper &oper) {
        if (oper.t != 2) {
            os << oper.t << " " << oper.ind << " " << oper.s;
        } else {
            cout << oper.t << " " << oper.ind;
        }
        return os;
    }

    bool operator<(const oper &rhs) const {
        return std::tie(t, ind, s) < std::tie(rhs.t, rhs.ind, rhs.s);
    }

    bool operator>(const oper &rhs) const {
        return rhs < *this;
    }

    bool operator<=(const oper &rhs) const {
        return !(rhs < *this);
    }

    bool operator>=(const oper &rhs) const {
        return !(*this < rhs);
    }
};


int cnt_digits(int x) {
    if (x == 0) return 0;
    int cnt = 0;
    while (x != 0) {
        ++cnt;
        x /= 10;
    }
    return cnt;
}


int min_num(int cnt) {
    int res = 1;
    for (int i = 0; i < cnt - 1; ++i) {
        res *= 10;
    }
    return res;
}


int get_len(int cnt, char s) {
    if (cnt == 1) return 1;
    if (cnt <= 0) return 0;
    return cnt_digits(cnt) + 1;
}

vector<char> gens = {'A', 'G', 'C', 'T'};

char neq2(char s1, char s2) {
    for (char i: gens) {
        if (i != s1 && i != s2) return i;
    }
    assert(false);
}


pair<int, oper> maximize(int cnt, char s, char snext) {
    int len_now = get_len(cnt, s);
    int d = cnt_digits(cnt);
    vector<pair<int, oper>> variants;
    variants.emplace_back(get_len(cnt + 1, s) - len_now, oper(1, 0, s));
    variants.emplace_back(get_len(min_num(d), s) + get_len(1, neq2(s, snext)) + get_len(cnt - min_num(d), s) - len_now,
                          oper(1, min_num(d), neq2(s, snext)));
    if (d <= 2 && cnt >= 2) {
        variants.emplace_back(get_len(2, s) + get_len(1, neq2(s, snext)) + get_len(cnt - 2, s) - len_now,
                              oper(1, 2, neq2(s, snext)));
    }
    if (d != 1) {
        variants.emplace_back(
                get_len(min_num(d - 1), s) + get_len(1, neq2(s, snext)) + get_len(cnt - min_num(d - 1), s) - len_now,
                oper(1, min_num(d - 1), neq2(s, snext)));
    }
    sort(all(variants));
    return variants.back();
}

pair<int, oper> minimize(int cnt, char s) {
    int len_now = get_len(cnt, s);
    return {get_len(cnt - 1, s) - len_now, oper(2, 1)};
}

pair<int, oper> min_merge(int cnt1, char s1, int cnt2, char s2, int ind) {
    vector<pair<int, oper>> variants;
    int len_now = get_len(cnt1, s1) + get_len(cnt2, s2) + 1;
    if (s1 != s2) {
        variants.emplace_back(get_len(cnt1, s1) + get_len(cnt2, s2) - len_now, oper(2, ind));
    }
    if (s1 == s2) {
        variants.emplace_back(get_len(cnt1 + cnt2, s1) - len_now, oper(2, ind));
    }
    sort(all(variants));
    return variants.front();
}


pair<int, oper> max_merge(int cnt1, char s1, int cnt2, char s2, int ind, char mid) {
    vector<pair<int, oper>> variants;
    int len_now = get_len(cnt1, s1) + get_len(1, mid) + get_len(cnt2, s2);
//    variants.emplace_back(get_len(cnt1, s1) + get_len(1, mid) + get_len(cnt2, s2), oper(3, ind, neq2(s1, s2)));
    if (s1 != s2) {
        variants.emplace_back(get_len(cnt1 + 1, s1) + get_len(cnt2, s2) - len_now, oper(3, ind, s1));
        variants.emplace_back(get_len(cnt1, s1) + get_len(cnt2 + 1, s2) - len_now, oper(3, ind, s2));
    }
    if (s1 == s2) {
        variants.emplace_back(get_len(cnt1 + cnt2 + 1, s1) - len_now, oper(3, ind, s1));
    }
    sort(all(variants));
    return variants.back();
}

bool is_digit(char c) {
    return '0' <= c && c <= '9';
}


signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    string s;
    cin >> s;
    vector<pair<int, char>> blocks = {{0, '$'}};
    bool clear = true;
    int t = 1;
    for (int i = 0; i < s.size(); ++i) {
        if (is_digit(s[i])) {
            if (clear) clear = t = 0;
            t = t * 10 + (s[i] - '0');
        } else {
            blocks.emplace_back(t, s[i]);
            t = 1;
            clear = true;
        }
    }
    blocks.emplace_back(0, '$');
    vector<pair<int, oper>> variants;
    int prev = 0;
    for (int i = 1; i < (int) blocks.size() - 1; ++i) {
        auto mx_one = maximize(blocks[i].first, blocks[i].second, blocks[i + 1].second);
        mx_one.second.ind += prev;
        variants.emplace_back(mx_one);
        auto mn_one = minimize(blocks[i].first, blocks[i].second);
        mn_one.second.ind += prev;
        variants.emplace_back(mn_one);
        prev += blocks[i].first;
    }
    prev = blocks[1].first;
    for (int i = 2; i < (int) blocks.size() - 2; ++i) {
        if (blocks[i].first == 1) {
            auto mx_merge = max_merge(blocks[i - 1].first, blocks[i - 1].second, blocks[i + 1].first,
                                      blocks[i + 1].second, prev + 1, blocks[i].second);
            auto mn_merge = min_merge(blocks[i - 1].first, blocks[i - 1].second, blocks[i + 1].first,
                                      blocks[i + 1].second, prev + 1);
            variants.emplace_back(mn_merge);
            variants.emplace_back(mx_merge);
        }
        prev += blocks[i].first;
    }
    sort(all(variants));
    cout << variants.front().second  << "\n";
    cout << variants.back().second  << "\n";
}
